#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Comment/Review Editor
# DIZ: Enables you to edit reviews/comments that has been added by visitors for links.
# GRAPHIC: ic_comment.gif
# VERSION: 1.0
# 
###########################################

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

## REQUIRES MySQL Version 3.23.23+  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$imports_per_screen = 10;
$web_wait = 0;


##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}




sub start
{

$sortby = $q->param('sortby');

if ($sortby eq "Date"){ $orderby = "ORDER BY B.date DESC"; }
if ($sortby eq "Title"){ $orderby = "ORDER BY A.title ASC"; }
if ($sortby eq "Number of Reviews"){ $orderby = "ORDER BY A.rev_no DESC";  }


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

#$sql = "SELECT A.title, A.description, A.url, A.rev_no, A.lnkid, B.rname, B.remail, B.review, B.approved, B.date, B.rvid 
#				FROM links AS A, reviews AS B WHERE 
#				((A.rev_no IS NOT NULL) OR (A.rev_no > 0)) AND (A.lnkid = B.lnkid) $orderby";


$sql = "SELECT A.title, A.description, A.url, A.rev_no, A.lnkid, B.rname, B.remail, B.review, B.approved, B.date, B.rvid 
				FROM links AS A, reviews AS B WHERE 
				(A.lnkid = B.lnkid) AND (B.approved != 'N') $orderby";


$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows(); 


if ($rows == 0)
	{

$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "Reviews/Comments Editor", qq[
There are no Reviews/Comments at present.
]);
	
print qq[
<html>
<head>
<title>Reviews</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
$hbox
</body>
</html>
];
exit;
	
	}


$scnt = 0;
$rowspages = 0;

$ldata = &get_file_contents("$data_dir/keyscom.dat"); 
@allditems = split (/\n/, $ldata);


	while ( @row = $sth->fetchrow() )
	{
	$lnkid = $row[4];
	
		$founda = "false";
		foreach $lnkitem (@lnka)
			{
			if ($lnkitem == $lnkid)
				{
				$founda = "true";
				}
			}

		if ($founda eq "false") 
			{
			push (@lnka, $lnkid); 
			$objname = "links" . "$lnkid";
			$obj{$objname} = qq[
			<table border="0" cellspacing="1" width="100%" cellpadding="6" style="border: 1px solid rgb(216,216,216)">
			  <tr>
			    <td width="100%" background="$web_url/bar6.gif" class="normaltext"><strong>Link: <a href="$row[2]"
			    target="_blank">$row[0]</a></strong> [$row[3]]</td>
			  </tr>
			  <tr>
			    <td width="100%" class="normaltext">$row[1]
			    <p>!!comment_details!!</td>
			  </tr>
			</table>
			<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
			  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
			</table>
			-:-:oo::$row[4]];
			
			$rowspages++;
			}
	
	$tdate = acs::decode_date($row[9]);
	
	$diz_objname = "revs" . "$lnkid";
	if ($row[6] ne "") { $row[6] = " | " . $row[6]; }
	

	##################
	
	$all_extra = $row[7];
	my @extra_items = split (/o-o:o-o/, $all_extra);
	
	$comdisplay = $extra_items[0];
	
	$extcnt = 1;
	foreach $item (@allditems)
		{
		($ename, $echar, $ereq) = split (/\t/, $item);
			
			if ($ename ne "")
				{
				$extrafielddisp = $extra_items[$extcnt]; $extrafielddisp =~ s/\n/<BR>/g;
				$comdisplay = $comdisplay . "<BR><BR><b>$ename</b>: " . $extrafielddisp;
				}
		
		$extcnt++;
		}
		
		
	
	$diz_obj{$diz_objname} = $diz_obj{$diz_objname} . qq[
<div align="center"><center>
<table border="0" cellspacing="0" width="90%" cellpadding="0">
  <tr class="normaltext">
    <td width="100%"><strong>Comment By: <font color="#0000A0">$row[5]</font> $row[6] </strong><i>$tdate</i></td>
  </tr>
</table>
</center></div>
<div align="center"><center>
<table border="0" cellspacing="1" width="90%" cellpadding="3" style="border: 1px solid rgb(216,216,216)">
  <tr class="normaltext">
    <td width="100%" class="normaltext">
    $comdisplay
    </td>
  </tr>
</table>
</center></div>
<div align="center"><center>
<table border="0" cellspacing="0" width="90%" cellpadding="0">
  <tr>
    <td width="100%" align="right" class="normaltext"><b>[<a
    href="$admin_url/admin14.cgi?fct=ropps&amp;notnew=true&amp;enr=1&amp;C0=$row[10]-$row[4]-0&amp;faction=Edit"
    onclick="popup('$admin_url/admin14.cgi?fct=ropps&amp;notnew=true&amp;enr=1&amp;C0=$row[10]-$row[4]-0&amp;faction=Edit',800,500);return false;">Edit</a>
    | <a
    href="$admin_url/admin14.cgi?fct=ropps&amp;notnew=true&amp;enr=1&amp;C0=$row[10]-$row[4]-0&amp;faction=Delete2"
    onclick="popup('$admin_url/admin14.cgi?fct=ropps&amp;notnew=true&amp;enr=1&amp;C0=$row[10]-$row[4]-0&amp;faction=Delete2',800,500);return false;">Delete</a>]</b></td>
  </tr>
</table>
</center></div>


	];
	
	$scnt++;
	}



#######

$nrres = $q->param('results'); 
if ($nrres eq "") { $nrres = 5; }

$icnt = $rowspages;
$nr_searchres = $nrres;

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$main_nd = $nd;
$main_st = $st;

$ippc = 1; 



foreach $item (@lnka)
	{ 

	if (($ippc > $st) and ($ippc <= $nd))
		 { 
		 $objname = "links" . $item;
		 ($real_link, $lnkid) = split(/-:-:oo::/, $obj{$objname});
		 $diz_objname = "revs" . $lnkid;
		 
		 $real_link =~ s/!!comment_details!!/$diz_obj{$diz_objname}/g;
		 $alinks = $alinks . $real_link;
		 }
		
		$ippc++;
	}




  for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		}
	  	else
		{
		$st_a = ($pg * $nr_searchres) - $nr_searchres;
		$nd_a = ($pg * $nr_searchres);
		$pgstring = $pgstring . "<a href=\"$admin_url/p_comment.cgi?st=$st_a&nd=$nd_a&total=$rows&results=$nrres&sortby=$sortby\">$pg</a> ";
		}
	}
	
	if ($pgstring ne "") { $pgstring = "Pages: " . $pgstring; }
 



$sth->finish;
$dbh->disconnect;


### SET UP DROP DOWN BOXES

if ($nrres == 5) { $nrresa[0] = "selected"; }
if ($nrres == 10) { $nrresa[1] = "selected"; }
if ($nrres == 20) { $nrresa[2] = "selected"; }
if ($nrres == 30) { $nrresa[3] = "selected"; }
if ($nrres == 40) { $nrresa[4] = "selected"; }
if ($nrres == 50) { $nrresa[5] = "selected"; }
if ($nrres == 60) { $nrresa[6] = "selected"; }
if ($nrres == 80) { $nrresa[7] = "selected"; }
if ($nrres == 100) { $nrresa[8] = "selected"; }
if ($nrres == 200) { $nrresa[9] = "selected"; }
if ($nrres == 300) { $nrresa[10] = "selected"; }
if ($nrres == 500) { $nrresa[11] = "selected"; }

if ($sortby eq "Date") { $sort1 = "selected"; }
if ($sortby eq "Title") { $sort2 = "selected"; }
if ($sortby eq "Number of Reviews") { $sort3 = "selected"; }




########## 


$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "Comment/Review Editor", qq[
Enables you to edit reviews/comments that has been added by visitors for links.<BR>
<b>There are $rows Reviews/Comments in Total</b><BR>

  <form method="POST" action="$admin_url/p_comment.cgi">
      <p><strong>Sort By: <select name="sortby" size="1">
        <option value="Date" $sort1>Date</option>
        <option value="Title" $sort2>Title</option>
        <option value="Number of Reviews" $sort3>Number of Reviews</option>
      </select> List Links Per Page: <select name="results" size="1">
        <option value="5" $nrresa[0]>5</option>
        <option value="10" $nrresa[1]>10</option>
        <option value="20" $nrresa[2]>20</option>
        <option value="30" $nrresa[3]>30</option>
        <option value="40" $nrresa[4]>40</option>
        <option value="50" $nrresa[5]>50</option>
        <option value="60" $nrresa[6]>60</option>
        <option value="80" $nrresa[7]>80</option>
        <option value="100" $nrresa[8]>100</option>
        <option value="200" $nrresa[9]>200</option>
        <option value="300" $nrresa[10]>300</option>
        <option value="500" $nrresa[11]>500</option>
      </select> <input type="submit" value="  Go  " name="B1"></strong></p>
    </form>

]);  


print qq[

<html>
<head>
<title>Comment/Review Editor</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(100,40);
      myWindow.focus();

    }
 // End Hide -->
</script>
</head>
<body>

$hbox
<table border="0" cellspacing="6" width="100%" cellpadding="1">
  <tr>
    <td width="100%" class="normaltext">$pgstring</td>
  </tr>
</table>
$alinks

<table border="0" cellspacing="6" width="100%" cellpadding="1">
  <tr>
    <td width="100%" class="normaltext">$pgstring</td>
  </tr>
</table>

<BR><BR>



</body>
</html>
];

}


####################################################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


